/**
* user:  B1006
* fname: Dobrin
* lname: Bashev
* task:  bridges
* score: 50.0
* date:  2017-11-25 09:07:52.199828
*/
#include <iostream>
#include <vector>
#include <utility>
#define fi first
#define se second
using namespace std;

const int MAXN = 1005;
const int MAXM = 10005;

struct edge
{
    int u, v, w;
};

edge e[MAXM];
vector<int> g[MAXN];

int n, m;
int vis[MAXN], dir[MAXN];

void Init()
{
    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> e[i].u >> e[i].v;
        e[i].w = 0;
        g[e[i].u].emplace_back(i);
        g[e[i].v].emplace_back(i);
    }
}

vector<pair<int, int>> ext;
int term = -1, cont = 1;

void DFS(int u)
{
    vis[u] = 1;
    if (term != -1) return;

    while (dir[u] < g[u].size())
    {
        int idx = g[u][dir[u]];
        if (e[idx].w != 0)
        {
            dir[u]++;
            continue;
        }

        int v;
        if (e[idx].u != u) v = e[idx].u;
        else v = e[idx].v;

        e[idx].w = 1;
        dir[u]++;
        DFS(v);
        if (term != -1) return;
    }

    while (cont <= m)
    {
        if (e[cont].w == 0)
        {
            ext.emplace_back(u, e[cont].u);
            cont++;
            DFS(e[cont - 1].u);
            if (term != -1) return;
        }
        else cont++;
    }

    term = u;
}

void Print()
{
    cout << ext.size() << endl;
    for (int i = 0; i < ext.size(); ++ i)
    {
        cout << ext[i].fi << ' ' << ext[i].se << endl;
    }
}

int main()
{
    Init();

    DFS(1);

    for (int i = 1; i <= n; ++ i)
    {
        if (vis[i] == 0)
        {
            ext.emplace_back(term, i);
            term = i;
        }
    }

    if (term != 1)
    {
        ext.emplace_back(1, term);
    }

    Print();
    return 0;
}

/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
---
4 5
1 2
2 3
3 1
3 4
3 4
*/
