/**
* user:  B1006
* fname: Dobrin
* lname: Bashev
* task:  bridges
* score: 10.0
* date:  2017-11-25 12:13:39.190193
*/
#include <iostream>
#include <vector>
#define fi first
#define se second
#define endl '\n'
using namespace std;

const int MAXN = 1005;
const int MAXM = 10005;

struct edge
{
    int u, v, w;
};

edge e[MAXM];
vector<int> g[MAXN];

int n, m;
int vis1[MAXN], dir1[MAXN], con1[MAXN];

void Init()
{
    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> e[i].u >> e[i].v;
        e[i].w = 0;
        g[e[i].u].emplace_back(i);
        g[e[i].v].emplace_back(i);
    }
}

void DFS1(int u)
{
    vis1[u] = 1;

    for (int i = 0; i < g[u].size(); ++ i)
    {
        int idx = g[u][i], adj = -1;
        if (e[idx].u != u) adj = e[idx].u;
        if (e[idx].v != u) adj = e[idx].v;

        if (adj == -1) continue;
        if (vis1[adj] == 0)
        {
            dir1[u] = adj;
            DFS1(adj);
        }
        if (vis1[adj] == 1)
        {
            vector<int> tmp;
            while (adj != u)
            {
                tmp.push_back(adj);
                con1[adj] = 1;
                adj = dir1[adj];
            }

            for (int j = 0; j < tmp.size(); ++ j)
            {
                for (int k = 0; k < g[tmp[j]].size(); ++ k)
                {
                    int ind = g[tmp[j]][k];
                    if (con1[e[ind].u] == 1) e[ind].u = u;
                    if (con1[e[ind].v] == 1) e[ind].v = u;
                    if (e[ind].u != e[ind].v)
                    {
                        g[u].push_back(ind);
                    }
                }
                g[tmp[j]].clear();
            }
            for (int j = 0; j < g[u].size(); ++ j)
            {
                int idx = g[u][j];
                if (e[idx].u == u and e[idx].v == u) e[idx].w = 1;
            }
        }
    }

    vis1[u] = 2;
}


int vis2[MAXN], dir2[MAXN];
vector<pair<int, int>> ext;
int term = -1, cont = 1;

void DFS2(int u)
{
    //cout << u << endl;

    vis2[u] = 1;
    if (term != -1) return;

    while (dir2[u] < g[u].size())
    {
        int idx = g[u][dir2[u]];
        if (e[idx].w != 0)
        {
            dir2[u]++;
            continue;
        }

        int v = -1;
        if (e[idx].u != u) v = e[idx].u;
        if (e[idx].v != u) v = e[idx].v;

        if (v == -1)
        {
            dir2[u]++;
            continue;
        }

        e[idx].w = 1;
        dir2[u]++;
        DFS2(v);
        if (term != -1) return;
    }

    while (cont <= m)
    {
        if (con1[e[cont].u] == 1 or con1[e[cont].v] == 1)
        {
            cont++;
            continue;
        }
        if (e[cont].w == 0)
        {
            ext.emplace_back(u, e[cont].u);
            cont++;
            DFS2(e[cont - 1].u);
            if (term != -1) return;
        }
        else cont++;
    }

    term = u;
}

void Print()
{
    cout << ext.size() << endl;
    for (int i = 0; i < ext.size(); ++ i)
    {
        cout << ext[i].fi << ' ' << ext[i].se << endl;
    }
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        if (vis1[i] == 0) DFS1(i);
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (con1[i] == 0)
        {
            DFS2(i);
            break;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (vis2[i] == 0 and con1[i] == 0)
        {
            ext.emplace_back(term, i);
            term = i;
        }
    }

    if (term != 1)
    {
        ext.emplace_back(1, term);
    }

    Print();
    return 0;
}

/*
4 7
1 2
2 3
3 2
2 1
1 4
2 4
3 4
---
4 5
1 2
2 3
3 1
3 4
3 4
*/

