/**
* user:  B1016
* fname: Alex
* lname: Tsvetanov
* task:  bridges
* score: 20.0
* date:  2017-11-25 08:33:28.596999
*/
#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

int n, m;

bool power [1000];
int marks [1000];

set < int > ln [10000];

void marking_bfs (int s, int mark)
{
    queue <int> q;
    q.push (s);
    marks [s] = mark;
    while (not q.empty ())
    {
	auto x = q.front (); q.pop ();
	for (auto& y : ln [x])
	    if (marks [y] == 0)
	    {
		//cout << "Mark " << y << " as " << mark << endl;
		q.push (y);
		marks [y] = mark;
	    }
    }
    return ;
}

void answerForAComponent (int mark, vector < pair < int, int > >& answer)
{
    vector < int > my_comp;
    for (int i = 0 ; i < n ; i ++)
	if (marks [i] == mark)
	    my_comp.push_back (i);
    
    vector < int > odds;
    for (int i = 0 ; i < n ; i ++)
	if (power [i])
	    odds.push_back (i);
    for (int i = 0 ; i < odds.size () ; i += 2)
	answer.push_back ({odds [i] + 1, odds [i + 1] + 1});

    return ;
}

int getFromComponent (int mark)
{
    for (int i = 0 ; i < n ; i ++)
	if (marks [i] == mark)
	    return i + 1;
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    cin >> n >> m;
    
    for (int i = 0 ; i < m ; i ++)
    {
	int a, b;
	cin >> a >> b;
	a --; b --;
	ln [a].insert (b);
	ln [b].insert (a);
	power [a] = not power [a];
	power [b] = not power [b];
    }
    
    vector < pair < int, int > > answer;

    int comps = 0;
    for (int i = 0 ; i < n ; i ++)
	if (marks [i] == 0)
	{
	    //cout << "Component starts from " << i + 1 << endl;
	    marking_bfs (i, ++comps);
	    answerForAComponent (comps, answer);
	    for (int j = 1 ; j < comps ; j ++)
	    {
		int x = getFromComponent (j);
		answer.push_back ({i + 1, x});
		answer.push_back ({i + 1, x});
		//cout << "Conecting components " << comps << " and " << j << " by (" << i + 1 << ", " << x << ")"<< endl;  
	    }
	}

    cout << answer.size () << endl;
    for (auto& x : answer)
	cout << x.first << " " << x.second << endl;
}

