/**
* user:  B1016
* fname: Alex
* lname: Tsvetanov
* task:  shopping
* score: 20.0
* date:  2017-11-25 09:39:04.468076
*/
#include <iostream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

string print (long long a)
{
    stringstream ss;
    bool minus = false;
    if (a < 0)
    {
	minus = true;
	a = -a;
	ss << '-';
    }

    if (a >= 10000000000)
    {
	for (int i = 2 ; i < sqrt(a) ; i ++)
	{
	    if (a % i == 0)
	    {
		ss << i << "*" << print (a / i);
		break;
	    }
	}
    }
    else
	ss << a;

    return ss.str ();
}

vector < long long > solve (vector < long long > x, long long n)
{
    if (x.size () == 2)
    {
	long long gcd = __gcd (x [0], x [1]);
	x [0] /= gcd;
	x [1] /= gcd;

	if (n % gcd != 0)
	    throw "No solutions";

	n /= gcd;

	long long q = x [1] % x [0];
	for (long long b = 0 ; b < x [0] ; b ++)
	    if ((b * q) % x [0] == n % x [0])
		return {(n - b * x [1]) / x [0], b};
    }
    if (x.size () == 3)
    {
	try { auto a = solve ({x [0], x [1]}, n); return {a [0], a [1], 0}; } catch (...) { }
	try { auto a = solve ({x [1], x [2]}, n); return {0, a [1], a [2]}; } catch (...) { }
	try { auto a = solve ({x [0], x [2]}, n); return {a [0], 0, a [2]}; } catch (...) { }
    }
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    int t;
    cin >> t;
    while (t--)
    {
	int k;
	cin >> k;
	vector < long long > x;
	for (int i = 0 ; i < k ; i ++)
	{
	    int a;
	    cin >> a;
	    x.push_back (a);
	}
	int n;
	cin >> n;
	try
	{
	    for (auto& a : solve (x, n))
	    {
		cout << print (a) << " ";
	    }
	    cout << endl;
	}
	catch (...)
	{
	    cout << "No solutions" << endl;
	}
    }
}

