/**
* user:  B1016
* fname: Alex
* lname: Tsvetanov
* task:  shopping
* score: 40.0
* date:  2017-11-25 10:37:48.455813
*/
#include <iostream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ull = long long;

string print (ull a)
{
    stringstream ss;
    bool minus = false;
    if (a < 0)
    {
	minus = true;
	a = -a;
	ss << '-';
    }

    if (a >= 10000000000)
    {
	for (int i = 2 ; i < sqrt(a) ; i ++)
	{
	    if (a % i == 0)
	    {
		ss << i << "*" << print (a / i);
		break;
	    }
	}
    }
    else
	ss << a;

    return ss.str ();
}

vector < ull > solveNative (vector < ull > x, ull n)
{
    if (x.size () == 2)
    {
	ull gcd = __gcd (x [0], x [1]);
	x [0] /= gcd;
	x [1] /= gcd;

	if (n % gcd != 0)
	    throw "No solutions";

	n /= gcd;

	ull q = x [1] % x [0];
	for (ull b = 0 ; b < x [0] ; b ++)
	    if ((b * q) % x [0] == n % x [0])
		return {(n - b * x [1]) / x [0], b};
    }
    if (x.size () == 3)
    {
	try { auto a = solveNative ({x [0], x [1]}, n); return {a [0], a [1], 0}; } catch (...) { }
	try { auto a = solveNative ({x [1], x [2]}, n); return {0, a [1], a [2]}; } catch (...) { }
	try { auto a = solveNative ({x [0], x [2]}, n); return {a [0], 0, a [2]}; } catch (...) { }
    }
    if (x.size () >= 4)
    {
	vector < ull > answer;
	for (auto& a : x)
	    answer.push_back (0);
	for (int i = 0 ; i < x.size () ; i ++)
	    for (int j = i + 1 ; j < x.size () ; j ++)
		if (n % __gcd (x [i], x [j]) == 0)
		    try 
		    { 
			auto a = solveNative ({x [i], x [j]}, n); 
			answer [i] = a [0];
			answer [j] = a [1];
			return std::move (answer);
		    } 
		    catch (...) 
		    { }
	throw "No solutions";
    }
}

vector < ull > solve (vector < ull > x, ull n)
{
    vector < pair < ull, int > > x_s;
    vector < ull > answer;
    for (int i = 0 ; i < x.size () ; i ++)
    {
	x_s.push_back ({x [i], i});
	answer.push_back (0);
    }
    sort (x_s.begin (), x_s.end ());
    pair < ull, int > curr;
    try
    {
	auto ASD = upper_bound (x_s.begin (), x_s.end (), make_pair(n, (int)x.size ()));
	if (ASD == x_s.begin ())
	    throw "Fuck you";
	curr = *prev (ASD);
    }
    catch (...)
    {
	try
	{
	    auto xx = solveNative (x, n);
	    for (int i = 0 ; i < x.size () ; i ++)
		answer [i] += xx [i];
	    return std::move (answer);
	}
	catch (...)
	{
	    throw "No solutions";
	}
    }
    auto xx = solve (x, n % curr.first);
    answer [curr.second] += n / curr.first;
    for (int i = 0 ; i < x.size () ; i ++)
	answer [i] += xx [i];
    return std::move (answer);
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    int t;
    cin >> t;
    while (t--)
    {
	int k;
	cin >> k;
	vector < ull > x;
	for (int i = 0 ; i < k ; i ++)
	{
	    int a;
	    cin >> a;
	    x.push_back (a);
	}
	int n;
	cin >> n;
	try
	{
	    for (auto& a : solve (x, n))
	    {
		cout << print (a) << " ";
	    }
	    cout << endl;
	}
	catch (...)
	{
	    cout << "No solutions" << endl;
	}
    }
}

