/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  chain
* score: 100.000000014
* date:  2017-11-25 10:52:13.436155
*/
#include <iostream>

const long long MAX_N = 5000000 + 3;
long long inp[MAX_N];
long long ans[MAX_N];
long long tree[MAX_N * 4];

long long n;
long long max = 0;
long long start = 1;


long long query(long long curr, long long idx, long long val, long long l, long long r) {
    //std::cout << "in " << curr << std::endl;
    if(r <= idx + start) return -1;
    if(curr >= l and curr < r) {
        if(inp[curr-start] > val) return curr - start;
        return -1;
    }
    if(tree[curr] <= val) {
        return -1;
    }
    long long m = (l + r) / 2;
    long long q = query(curr * 2, idx, val, l, m);
    if(q != -1) return q;
    return query(curr * 2 + 1, idx, val, m, r);

}

void build(long long idx, long long l, long long r) {
    //std::cout << idx << ' ' << l << ' ' << r << std::endl;
    if(idx >= l and idx < r) {
        tree[idx] = inp[idx - start];
        return;
    }
    const long long m = (l + r ) / 2;
    build(idx * 2, l, m);
    build(idx * 2 + 1, m, r);
    tree[idx] = std::max(tree[idx * 2], tree[idx * 2 + 1]);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cin >> n;
    for(long long i = 0;i < n;++ i) std::cin >> inp[i];

    while(start < n) start *= 2;
    //std::cout << start << std::endl;
    build(1, start, start*2);

    /*
    while(true) {
            long long a, b;
        std::cin >> a;
    std::cout << query(1, a, inp[a], start, start * 2) << std::endl;
    }*/

    ans[n-1] = 0;
    for(long long i = n-2;i >= 0;-- i) {
        long long q = query(1, i, inp[i], start, start * 2);
        if(q == -1) continue;
        ans[i] = ans[q] + 1;
    }

    for(long long i = 0;i < n;++ i) std::cout << ans[i] << ' ';
    return 0;
}
