/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  bridges
* score: 30.0
* date:  2017-11-25 11:26:45.209035
*/
#include <iostream>
#include <queue>
#include <set>

const int MAX_N = 1000 + 2;
int cnt[MAX_N];

int parent[MAX_N];
int evenN[MAX_N];

int find(int a) {
    if(parent[a] == -1 || parent[a] == a) return a;
    return parent[a] = find(parent[a]);
}

void unite(int a, int b) {
    parent[find(a)] = find(b);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    for(int i = 0;i < n;++ i) parent[i] = -1;

    /*while(true) {
        char a;
    int b,c;
    std::cin >> a >> b >> c;
    if(a == 'u') unite(b, c);
    else std::cout << find(b) << std::endl;
    }*/

    std::vector<std::pair<int, int>> ans;

    for(int i = 0;i < m;++ i) {
        int a, b;
        std::cin >> a >> b;
        a --;
        b --;
        //for(int i = 0;i < n;++ i) std::cout << parent[i] << ' ';
        //std::cout << std::endl;
        //std::cout << "TO DO " << a << " " << b << std::endl;
        unite(a, b);
        cnt[a] ++;
        cnt[b] ++;
    }

    std::set<int> evenC;
    for(int i = 0;i < n;++ i) {
        if(cnt[i] % 2 == 1) {
            int c = find(i);
            evenC.insert(c);
            evenN[c] = i;
        }
    }

    /// stage 1 - connect all even
    while(true) {
        while(evenC.size() >= 2) {
            int a = evenN[*evenC.begin()];
            evenC.erase(evenC.begin());
            int b = evenN[*evenC.begin()];
            evenC.erase(evenC.begin());
            unite(a, b);
            ans.push_back({a,b});
            cnt[a] ++;
            cnt[b] ++;
        }
        evenC.clear();
        for(int i = 0;i < n;++ i) {
            if(cnt[i] % 2 == 1) {
                int c = find(i);
                evenC.insert(c);
                evenN[c] = i;
            }
        }
        if(evenC.size() < 2) break;
    }

    if(evenC.size() == 1) {
        int c = *evenC.begin();
        int a = evenN[c];
        evenC.erase(evenC.begin());
        for(int i = 0;i < n;++ i) {
            int c1 = find(i);
            if(c1 != c) {
                unite(a, i);
                ans.push_back({a, i});
                cnt[a] ++;
                cnt[i] ++;
                break;
            }
        }
    }

    // there should be only 1 component now, either even or odd
    std::vector<int> evenNodes;
    for(int i = 0;i < n;++ i) {
        if(cnt[i] % 2 == 1) {
            evenNodes.push_back(i);
        }
    }

    if(evenNodes.size() % 2 == 1) { // no way
        std::cout << 0 << std::endl;
    } else {
        while(evenNodes.size()) {
            int a, b;
            a = evenNodes.back();
            evenNodes.pop_back();
            b = evenNodes.back();
            evenNodes.pop_back();
            ans.push_back({a, b});
            //unite(a, b);
        }
        std::cout << ans.size() << '\n';
        for(int i = 0;i < ans.size();++ i) {
            std::cout << ans[i].first+1 << ' ' << ans[i].second+1 << '\n';
        }
    }
    return 0;
}
