/**
* user:  B1083
* fname: Станислав Чавдаров Николов
* lname: София-град
* task:  bridges
* score: 30.0
* date:  2017-11-25 11:55:16.150966
*/
#include <iostream>
#include <queue>
#include <set>

const int MAX_N = 1000 + 2;
int cnt[MAX_N];

int parent[MAX_N];
int oddN[MAX_N];

int find(int a) {
    if(parent[a] == -1 || parent[a] == a) return a;
    return parent[a] = find(parent[a]);
}

void unite(int a, int b) {
    parent[find(a)] = find(b);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    for(int i = 0;i < n;++ i) parent[i] = -1;

    /*while(true) {
        char a;
    int b,c;
    std::cin >> a >> b >> c;
    if(a == 'u') unite(b, c);
    else std::cout << find(b) << std::endl;
    }*/

    std::vector<std::pair<int, int>> ans;

    for(int i = 0;i < m;++ i) {
        int a, b;
        std::cin >> a >> b;
        a --;
        b --;
        //for(int i = 0;i < n;++ i) std::cout << parent[i] << ' ';
        //std::cout << std::endl;
        //std::cout << "TO DO " << a << " " << b << std::endl;
        unite(a, b);
        cnt[a] ++;
        cnt[b] ++;
    }

    std::set<int> oddC;
    /// stage 1 - connect oddC-oddC
    while(true) {
        oddC.clear();
        for(int i = 0;i < n;++ i) {
            if(cnt[i] % 2 == 1) {
                int c = find(i);
                oddC.insert(c);
                oddN[c] = i;
            }
        }
        if(oddC.size() < 2) break;
        while(oddC.size() >= 2) {
            int a = oddN[*oddC.begin()];
            oddC.erase(oddC.begin());
            int b = oddN[*oddC.begin()];
            oddC.erase(oddC.begin());
            unite(a, b);
            ans.push_back({a,b});
            cnt[a] ++;
            cnt[b] ++;
        }
    }
    //std::cout << "end of stage 1: " << ans.size() << std::endl;

    if(oddC.size() == 1) { ///stage2
        std::cout << "HERE" << std::endl;
        int comp = *oddC.begin();
        oddC.clear();
        for(int i = 0;i < n;++ i) {
            int c = find(i);
            if(c != comp) {
                unite(i, oddN[comp]);
                cnt[i] ++;
                cnt[oddN[comp]] ++;
                ans.push_back({i,oddN[comp]});
                break;
            }
        }
    }

    /// stage 3
    std::set<int> allC;

    while(true) {
        allC.clear();
        for(int i = 0;i < n;++ i) oddN[find(i)] = i;
        for(int i = 0;i < n;++ i) {
            int c = find(i);
            allC.insert(c);
            if(cnt[i] % 2 == 1) {
                oddN[c] = i;
            }
        }
        if(allC.size() < 2) break;
        while(allC.size() >= 2) {
            int a = oddN[*allC.begin()];
            allC.erase(allC.begin());
            int b = oddN[*allC.begin()];
            allC.erase(allC.begin());
            unite(a, b);
            ans.push_back({a,b});
            cnt[a] ++;
            cnt[b] ++;
        }
    }

    /// stage4: there should be only 1 component now, either odd or even
    std::vector<int> oddNodes;
    for(int i = 0;i < n;++ i) {
        if(cnt[i] % 2 == 1) {
            oddNodes.push_back(i);
        }
    }
    //std::cout << "end of stage 2: " << ans.size() << std::endl;


    if(oddNodes.size() % 2 == 1) { // no way
        std::cout << 0 << std::endl;
    } else {
        while(oddNodes.size()) {
            int a, b;
            a = oddNodes.back();
            oddNodes.pop_back();
            b = oddNodes.back();
            oddNodes.pop_back();
            ans.push_back({a, b});
            //unite(a, b);
        }
        std::cout << ans.size() << std::endl;
        for(int i = 0;i < ans.size();++ i) {
            std::cout << ans[i].first+1 << ' ' << ans[i].second+1 << std::endl;
        }
    }
    return 0;
}
